classdef Alphabet
    properties (SetAccess = private)
        chars
    end
    properties (Dependent = true)
        num_nucl
    end
    
    methods
        function obj = Alphabet(chars)
            obj.chars = chars;
        end
        
        function num_nucl = get.num_nucl(obj)
            num_nucl = length(obj.chars);
        end
        
        function char = idx_to_char(obj, idx)
            if (idx < 1) || (idx > obj.num_nucl)
                error('Trying to convert an integer to an element of the alphabet which is too small/large')
            end
            char = obj.chars(idx);
        end
        function idx = char_to_idx(obj, char)
            matches = find(obj.chars == char);
            if length(matches) ~= 1
                error(['Trying to convert an character to an index which is not member of the alphabet: ' char])
            end
            idx = matches(1);
        end        
    end
    
    methods (Static = true)
        function b = is_gap(char)
            b = (char == '-');
        end
    end

end