classdef GridEngine
    methods (Static)
        % get number of jobs running on cluster
        function num = num_running_jobs()
            cmd = 'ssh fe ". /opt/sge/default/common/settings.sh; qstat -u ''*'' | grep -c ''.*[[:space:]]r[[:space:]].*'' " ';
            [st, rs] = system(cmd);
            num = str2num(rs);
            cmd = 'ssh fe ". /opt/sge/default/common/settings.sh; qstat -u ''*'' | grep -c ''.*[[:space:]]dr[[:space:]].*'' " ';
            [st, rs] = system(cmd);
            num = num + str2num(rs);
            cmd = 'ssh fe ". /opt/sge/default/common/settings.sh; qstat -u ''*'' | grep -c ''.*[[:space:]]qw[[:space:]].*'' " ';
            [st, rs] = system(cmd);
            num = num + str2num(rs);
        end
        
        function node_numbers = get_allocated_nodes()
            user_name = 'ingo';
            cmd = ['ssh fe ". /opt/sge/default/common/settings.sh; qstat | grep ''QLOGIN.*' user_name ' '' " '];
            [st, rs] = system(cmd);
            idx = findstr('all.q@node', rs);
            node_numbers = {};
            s = length('all.q@node');
            for i=1:length(idx)
                node_numbers{i} = rs((s + idx(i)):(s + idx(i) + 1));
            end
        end
    end
end