classdef Seq < handle
    properties
        name
        genome
        sub
        pos_with_gaps
        pos_without_gaps
    end
    properties (Dependent = true)
        len        
    end
    
    methods
        function s = Seq(name, genome, sub)
            s.name = name;
            s.genome = genome;
            s.sub = sub;
            
            s.pos_with_gaps = [];
            s.pos_without_gaps = [];
            n = 0;
            for i=1:length(genome)
                if ~Alpha.is_gap(s.genome(i))
                    n = n + 1;
                    s.pos_with_gaps(n) = i;
                end
                s.pos_without_gaps(i) = n;
            end
        end
        
        function len = get.len(obj)
            len = length(obj.genome);
        end

        function ret = is_valid_pos_without_gaps(obj, pos)            
            ret = (pos >= 1) && (pos <= length(obj.pos_with_gaps));
        end
        
    end
end



