classdef SubSizePara < BasicPara
    properties 
        small_subs
        large_subs
    end
    properties (Dependent = true)
        num_small_subs
        num_large_subs
    end
    
    methods
        function obj = SubSizePara(jp, small_subs, large_subs)
            %global consts;
            obj@BasicPara(jp);
            if (~isempty(intersect(small_subs, large_subs)))
                error 'Intersect of small and large subs is not empty'
            end
            
            %{
            A = char(sort(union(small_subs, large_subs)));
            B = char(sort(consts.subs.names));
            size(A)
            size(B)
            if (size(A) ~= size(B)) || (A ~= B)
                error 'Intersect of small and large subs is unequal the set of all subs'
            end
            %}
            
            obj.small_subs = small_subs;
            obj.large_subs = large_subs;
        end
        
        function num_small_subs = get.num_small_subs(obj)
            num_small_subs = length(obj.small_subs);
        end
        function num_large_subs = get.num_large_subs(obj)
            num_large_subs = length(obj.large_subs);
        end        
    end
end